
#include <stdlib.h>
 
#include "random.h"
#include "trafgen.h"
#include "ranvar.h"

/* 
 * Web traffic source based on switched ethernet traffic 
 */

class WEB_Traffic_CDF : public TrafficGenerator {
 public:
	WEB_Traffic_CDF();
	virtual double next_interval(int&);
	//HACK so that udp agent knows interpacket arrival time within a burst
	inline double interval() { return (interval_); }
        int             command(int argc, const char* const* argv); 

 protected:
        
	virtual void start();
	void init();
        double interval_;

        EmpiricalRandomVariable *interval_cdf_;
        EmpiricalRandomVariable *pktsize_cdf_;
	char cdffile[256];

};


static class WEBTrafficCDFClass : public TclClass {
 public:
	WEBTrafficCDFClass() : TclClass("Application/Traffic/WEBCDF") {}
	TclObject* create(int, const char*const*) {
		return (new WEB_Traffic_CDF());
	}
} class_web_traffic_cdf;

WEB_Traffic_CDF::WEB_Traffic_CDF() 
{
  interval_cdf_ = new EmpiricalRandomVariable();
  pktsize_cdf_ = new EmpiricalRandomVariable();

}

void WEB_Traffic_CDF::init()
{
  char *p = cdffile;
  interval_cdf_ ->loadCDF(p);
  pktsize_cdf_->loadCDF("pktsize.cdf");
	
}

void WEB_Traffic_CDF::start()
{
        init();
        running_ = 1;
        timeout();
}

double WEB_Traffic_CDF::next_interval(int& size)
{

        double t = interval_cdf_->value() ;
	if (t < 0.00005) t = 0.00005;
	interval_ = t;
	
	int size_ = (int)pktsize_cdf_->value();
	if (size_ < 64) size_ = 64;

	// rate can not surpass 70M
	while ((size_<<3)/t > 70000000) {
	    size_ = (int)pktsize_cdf_->value();
	}

	size = size_;

	return(t);

}

int
WEB_Traffic_CDF::command(int argc, const char* const* argv)
{                                     
  
  if(argc == 3) {
    if (strcasecmp(argv[1], "attach-intervalfile") == 0) {
      strcpy(cdffile,argv[2]);
      return TCL_OK;
    }

  }
  return (TrafficGenerator::command(argc, argv));
}
